# coding: utf-8

"""
    Event Ingestion API

    Event Ingestion API for DataKitchen’s DataOps Observability  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@datakitchen.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class MetricLogApiSchema(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'task_key': 'str',
        'task_name': 'str',
        'run_key': 'str',
        'metric_value': 'float',
        'pipeline_key': 'str',
        'metric_key': 'str',
        'pipeline_name': 'str',
        'external_url': 'str',
        'metadata': 'object',
        'event_timestamp': 'datetime'
    }

    attribute_map = {
        'task_key': 'task_key',
        'task_name': 'task_name',
        'run_key': 'run_key',
        'metric_value': 'metric_value',
        'pipeline_key': 'pipeline_key',
        'metric_key': 'metric_key',
        'pipeline_name': 'pipeline_name',
        'external_url': 'external_url',
        'metadata': 'metadata',
        'event_timestamp': 'event_timestamp'
    }

    def __init__(self, task_key=None, task_name=None, run_key=None, metric_value=None, pipeline_key=None, metric_key=None, pipeline_name=None, external_url=None, metadata=None, event_timestamp=None):  # noqa: E501
        """MetricLogApiSchema - a model defined in Swagger"""  # noqa: E501
        self._task_key = None
        self._task_name = None
        self._run_key = None
        self._metric_value = None
        self._pipeline_key = None
        self._metric_key = None
        self._pipeline_name = None
        self._external_url = None
        self._metadata = None
        self._event_timestamp = None
        self.discriminator = None
        if task_key is not None:
            self.task_key = task_key
        if task_name is not None:
            self.task_name = task_name
        if run_key is not None:
            self.run_key = run_key
        self.metric_value = metric_value
        self.pipeline_key = pipeline_key
        self.metric_key = metric_key
        if pipeline_name is not None:
            self.pipeline_name = pipeline_name
        if external_url is not None:
            self.external_url = external_url
        if metadata is not None:
            self.metadata = metadata
        if event_timestamp is not None:
            self.event_timestamp = event_timestamp

    @property
    def task_key(self):
        """Gets the task_key of this MetricLogApiSchema.  # noqa: E501

        Optional. The target task for the event action. Must be unique within a pipeline.  # noqa: E501

        :return: The task_key of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._task_key

    @task_key.setter
    def task_key(self, task_key):
        """Sets the task_key of this MetricLogApiSchema.

        Optional. The target task for the event action. Must be unique within a pipeline.  # noqa: E501

        :param task_key: The task_key of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """

        self._task_key = task_key

    @property
    def task_name(self):
        """Gets the task_name of this MetricLogApiSchema.  # noqa: E501

        Optional. A human-readable display name for the task.  # noqa: E501

        :return: The task_name of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._task_name

    @task_name.setter
    def task_name(self, task_name):
        """Sets the task_name of this MetricLogApiSchema.

        Optional. A human-readable display name for the task.  # noqa: E501

        :param task_name: The task_name of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """

        self._task_name = task_name

    @property
    def run_key(self):
        """Gets the run_key of this MetricLogApiSchema.  # noqa: E501

        The key of the target run for the event action. This identifier is created and managed by the user. If no run_key is specified, the event applies to the default open run for the pipeline.  # noqa: E501

        :return: The run_key of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._run_key

    @run_key.setter
    def run_key(self, run_key):
        """Sets the run_key of this MetricLogApiSchema.

        The key of the target run for the event action. This identifier is created and managed by the user. If no run_key is specified, the event applies to the default open run for the pipeline.  # noqa: E501

        :param run_key: The run_key of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """

        self._run_key = run_key

    @property
    def metric_value(self):
        """Gets the metric_value of this MetricLogApiSchema.  # noqa: E501

        Required. The decimal value to be logged. NaN/INF values are not supported.  # noqa: E501

        :return: The metric_value of this MetricLogApiSchema.  # noqa: E501
        :rtype: float
        """
        return self._metric_value

    @metric_value.setter
    def metric_value(self, metric_value):
        """Sets the metric_value of this MetricLogApiSchema.

        Required. The decimal value to be logged. NaN/INF values are not supported.  # noqa: E501

        :param metric_value: The metric_value of this MetricLogApiSchema.  # noqa: E501
        :type: float
        """
        if metric_value is None:
            raise ValueError("Invalid value for `metric_value`, must not be `None`")  # noqa: E501

        self._metric_value = metric_value

    @property
    def pipeline_key(self):
        """Gets the pipeline_key of this MetricLogApiSchema.  # noqa: E501

        Required. The target pipeline for the event action.  # noqa: E501

        :return: The pipeline_key of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_key

    @pipeline_key.setter
    def pipeline_key(self, pipeline_key):
        """Sets the pipeline_key of this MetricLogApiSchema.

        Required. The target pipeline for the event action.  # noqa: E501

        :param pipeline_key: The pipeline_key of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """
        if pipeline_key is None:
            raise ValueError("Invalid value for `pipeline_key`, must not be `None`")  # noqa: E501

        self._pipeline_key = pipeline_key

    @property
    def metric_key(self):
        """Gets the metric_key of this MetricLogApiSchema.  # noqa: E501

        Required. The string value for grouping the metric. This value is created and managed by the user.  # noqa: E501

        :return: The metric_key of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._metric_key

    @metric_key.setter
    def metric_key(self, metric_key):
        """Sets the metric_key of this MetricLogApiSchema.

        Required. The string value for grouping the metric. This value is created and managed by the user.  # noqa: E501

        :param metric_key: The metric_key of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """
        if metric_key is None:
            raise ValueError("Invalid value for `metric_key`, must not be `None`")  # noqa: E501

        self._metric_key = metric_key

    @property
    def pipeline_name(self):
        """Gets the pipeline_name of this MetricLogApiSchema.  # noqa: E501

        Optional. Human readable display value for a pipeline.  # noqa: E501

        :return: The pipeline_name of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_name

    @pipeline_name.setter
    def pipeline_name(self, pipeline_name):
        """Sets the pipeline_name of this MetricLogApiSchema.

        Optional. Human readable display value for a pipeline.  # noqa: E501

        :param pipeline_name: The pipeline_name of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """

        self._pipeline_name = pipeline_name

    @property
    def external_url(self):
        """Gets the external_url of this MetricLogApiSchema.  # noqa: E501

        A link to source information.  # noqa: E501

        :return: The external_url of this MetricLogApiSchema.  # noqa: E501
        :rtype: str
        """
        return self._external_url

    @external_url.setter
    def external_url(self, external_url):
        """Sets the external_url of this MetricLogApiSchema.

        A link to source information.  # noqa: E501

        :param external_url: The external_url of this MetricLogApiSchema.  # noqa: E501
        :type: str
        """

        self._external_url = external_url

    @property
    def metadata(self):
        """Gets the metadata of this MetricLogApiSchema.  # noqa: E501

        Arbitrary key-value information, supplied by the user, to apply to the event.  # noqa: E501

        :return: The metadata of this MetricLogApiSchema.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this MetricLogApiSchema.

        Arbitrary key-value information, supplied by the user, to apply to the event.  # noqa: E501

        :param metadata: The metadata of this MetricLogApiSchema.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def event_timestamp(self):
        """Gets the event_timestamp of this MetricLogApiSchema.  # noqa: E501

        An ISO8601 timestamp that describes when the event occurred. If no timezone is specified, UTC is assumed. If unset, the Event Ingestion API applies its current time to the field.  # noqa: E501

        :return: The event_timestamp of this MetricLogApiSchema.  # noqa: E501
        :rtype: datetime
        """
        return self._event_timestamp

    @event_timestamp.setter
    def event_timestamp(self, event_timestamp):
        """Sets the event_timestamp of this MetricLogApiSchema.

        An ISO8601 timestamp that describes when the event occurred. If no timezone is specified, UTC is assumed. If unset, the Event Ingestion API applies its current time to the field.  # noqa: E501

        :param event_timestamp: The event_timestamp of this MetricLogApiSchema.  # noqa: E501
        :type: datetime
        """

        self._event_timestamp = event_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MetricLogApiSchema, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MetricLogApiSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
